Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 5099)
@@ -2142,23 +2078,23 @@
 
 
-      CALL coarsemission(pctsrf,pdtphys,t_seri,                            &
-                        pmflxr,pmflxs,prfl,psfl,                           &
-                        rlat,rlon,debutphy,                                & 
-                        zu10m,zv10m,wstar,ale_bl,ale_wake,                 &
-                        scale_param_ssacc,scale_param_sscoa,               & 
-                        scale_param_dustacc,scale_param_dustcoa,           &
-                        scale_param_dustsco,                               & 
-                        nbreg_dust,                                        &
-                        iregion_dust,dust_ec,                              & 
-                        param_wstarBLperregion,param_wstarWAKEperregion,   &
-                        nbreg_wstardust,                                   &
-                        iregion_wstardust,                                 &
-                        lmt_sea_salt,qmin,qmax,                            &
-                                  flux_sparam_ddfine,flux_sparam_ddcoa,    & 
-                                  flux_sparam_ddsco,                       &
-                                  flux_sparam_ssfine,flux_sparam_sscoa,    & 
-                              id_prec,id_fine,id_coss,id_codu,id_scdu,     &
-                              ok_chimeredust,                           &
-                                                     source_tr,flux_tr)    
+    CALL coarsemission(pctsrf, pdtphys, t_seri, &
+            pmflxr, pmflxs, prfl, psfl, &
+            rlat, rlon, debutphy, &
+            zu10m, zv10m, wstar, ale_bl, ale_wake, &
+            scale_param_ssacc, scale_param_sscoa, &
+            scale_param_dustacc, scale_param_dustcoa, &
+            scale_param_dustsco, &
+            nbreg_dust, &
+            iregion_dust, dust_ec, &
+            param_wstarBLperregion, param_wstarWAKEperregion, &
+            nbreg_wstardust, &
+            iregion_wstardust, &
+            lmt_sea_salt, qmin, qmax, &
+            flux_sparam_ddfine, flux_sparam_ddcoa, &
+            flux_sparam_ddsco, &
+            flux_sparam_ssfine, flux_sparam_sscoa, &
+            id_prec, id_fine, id_coss, id_codu, id_scdu, &
+            ok_chimeredust, &
+            source_tr, flux_tr)
 
 #ifdef IOPHYS_DUST
@@ -2170,21 +2106,20 @@
 #endif
 
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_coarem')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after coarem')
-        ENDDO
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after coarem')
-      ENDIF
-
-!
-!
-!
-!======================================================================
-!                   EMISSIONS OF AEROSOL PRECURSORS      
-!======================================================================
-!
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_coarem')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after coarem')
+      ENDDO
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: after coarem')
+    ENDIF
+
+
+
+    !======================================================================
+    !                   EMISSIONS OF AEROSOL PRECURSORS
+    !======================================================================
+
 #ifdef IOPHYS_DUST
       print *,'INPUT TO PRECUREMISSION'
@@ -2229,36 +2164,36 @@
 
 
-     print*,'ON PASSE DANS precuremission'
-     CALL precuremission(ftsol,u10m_ec,v10m_ec,pctsrf,                  &
-                         u_seri,v_seri,paprs,pplay,cdragh,cdragm,       &
-                         t_seri,q_seri,tsol,fracso2emis,frach2sofso2,   &
-                         bateau,zdz,zalt,kminbc,kmaxbc,pdtphys,         &
-                         scale_param_bb,scale_param_ind,                &
-                         iregion_ind, iregion_bb,                       &
-                         nbreg_ind, nbreg_bb,                           &
-                         lmt_so2ff_l,lmt_so2ff_h, lmt_so2nff,lmt_so2ba, &
-                         lmt_so2bb_l,lmt_so2bb_h,                       &
-                         lmt_so2volc_cont,lmt_altvolc_cont,             &
-                         lmt_so2volc_expl,lmt_altvolc_expl,             &
-                         lmt_dmsbio,lmt_h2sbio, lmt_dmsconc, lmt_dms,   &
-                         id_prec,id_fine,                               &
-                                       flux_sparam_ind, flux_sparam_bb, &
-                                       source_tr,flux_tr,tr_seri)       
-!
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after precur')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after precur')
-        ENDDO
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after precur')
-      ENDIF
-
-!=======================================================================
-!                      EMISSIONS OF FINE AEROSOLS
-!=======================================================================
+    print*, 'ON PASSE DANS precuremission'
+    CALL precuremission(ftsol, u10m_ec, v10m_ec, pctsrf, &
+            u_seri, v_seri, paprs, pplay, cdragh, cdragm, &
+            t_seri, q_seri, tsol, fracso2emis, frach2sofso2, &
+            bateau, zdz, zalt, kminbc, kmaxbc, pdtphys, &
+            scale_param_bb, scale_param_ind, &
+            iregion_ind, iregion_bb, &
+            nbreg_ind, nbreg_bb, &
+            lmt_so2ff_l, lmt_so2ff_h, lmt_so2nff, lmt_so2ba, &
+            lmt_so2bb_l, lmt_so2bb_h, &
+            lmt_so2volc_cont, lmt_altvolc_cont, &
+            lmt_so2volc_expl, lmt_altvolc_expl, &
+            lmt_dmsbio, lmt_h2sbio, lmt_dmsconc, lmt_dms, &
+            id_prec, id_fine, &
+            flux_sparam_ind, flux_sparam_bb, &
+            source_tr, flux_tr, tr_seri)
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after precur')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after precur')
+      ENDDO
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: after precur')
+    ENDIF
+
+    !=======================================================================
+    !                      EMISSIONS OF FINE AEROSOLS
+    !=======================================================================
 #ifdef IOPHYS_DUST
-!
+
       do itr=1,nbtr
          write(str2,'(i2.2)') itr
@@ -2268,41 +2203,38 @@
 #endif
 
-      CALL finemission(zdz,pdtphys,zalt,kminbc,kmaxbc,                     & 
-                      scale_param_bb,scale_param_ff,                       &
-                      iregion_ind,iregion_bb,                              & 
-                      nbreg_ind,nbreg_bb,                                  & 
-                      lmt_bcff, lmt_bcnff, lmt_bcbb_l,lmt_bcbb_h,          & 
-                      lmt_bcba, lmt_omff, lmt_omnff,                       & 
-                      lmt_ombb_l, lmt_ombb_h, lmt_omnat, lmt_omba,         & 
-                      id_fine,                                             & 
-                                       flux_sparam_bb, flux_sparam_ff,     & 
-                                             source_tr,flux_tr,tr_seri)     
-!
-!
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_fineem')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after fineem')
-        ENDDO
+    CALL finemission(zdz, pdtphys, zalt, kminbc, kmaxbc, &
+            scale_param_bb, scale_param_ff, &
+            iregion_ind, iregion_bb, &
+            nbreg_ind, nbreg_bb, &
+            lmt_bcff, lmt_bcnff, lmt_bcbb_l, lmt_bcbb_h, &
+            lmt_bcba, lmt_omff, lmt_omnff, &
+            lmt_ombb_l, lmt_ombb_h, lmt_omnat, lmt_omba, &
+            id_fine, &
+            flux_sparam_bb, flux_sparam_ff, &
+            source_tr, flux_tr, tr_seri)
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_fineem')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after fineem')
+      ENDDO
       IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,   &
-           pplay,t_seri,iscm3,'after fineem')                  
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'after fineem')
         ENDDO
       ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after fineem')
-      ENDIF
-
-!
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_emis=dife*MAX(0,SIGN(1,dife))   &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_emis=tia_emis+REAL(ti_emis)/REAL(clock_rate)
-      ENDIF
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: after fineem')
+    ENDIF
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+      dife = clock_end - clock_start
+      ti_emis = dife * MAX(0, SIGN(1, dife))   &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_emis = tia_emis + REAL(ti_emis) / REAL(clock_rate)
+    ENDIF
 
 
@@ -2314,56 +2246,52 @@
       enddo
 #endif
-!
-!
-
-
-
-!
-!=======================================================================
-!                 DRY DEPOSITION AND BOUNDARY LAYER MIXING
-!=======================================================================
-!
-!        DO itr=1,nbtr
-!         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,
-!     .      pplay,t_seri,iscm3,'')
-!        ENDDO
-
-!======================================================================
-!    -- Dry deposition --
-!======================================================================
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+
+
+    !=======================================================================
+    !                 DRY DEPOSITION AND BOUNDARY LAYER MIXING
+    !=======================================================================
+
+    !        DO itr=1,nbtr
+    !         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,
+    !     .      pplay,t_seri,iscm3,'')
+    !        ENDDO
+
+    !======================================================================
+    !    -- Dry deposition --
+    !======================================================================
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_start)
+    ENDIF
+
+    DO itr = 1, nbtr
+      DO j = 1, klev
+        DO i = 1, klon
+          tmp_var(i, j) = tr_seri(i, j, itr)
+        ENDDO
+      ENDDO
+      CALL cm3_to_kg(pplay, t_seri, tmp_var)
+      DO j = 1, klev
+        DO i = 1, klon
+          tr_seri(i, j, itr) = tmp_var(i, j)
+        ENDDO
+      ENDDO
+    ENDDO
+    iscm3 = .false.
+    !----------------------------
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_before_depo')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before depo')
+      ENDDO
+      IF (lcheckmass) THEN
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'before depo')
+        ENDDO
       ENDIF
-
-      DO itr=1,nbtr
-         DO j=1,klev
-         DO i=1,klon
-           tmp_var(i,j)=tr_seri(i,j,itr)
-         ENDDO 
-         ENDDO
-         CALL cm3_to_kg(pplay,t_seri,tmp_var)
-         DO j=1,klev
-         DO i=1,klon
-           tr_seri(i,j,itr)=tmp_var(i,j)
-         ENDDO 
-         ENDDO
-      ENDDO
-      iscm3=.false.
-!----------------------------
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_before_depo')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before depo')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz, &
-           pplay,t_seri,iscm3,'before depo')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: before depo')
-      ENDIF
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: before depo')
+    ENDIF
 
 #ifdef IOPHYS_DUST
@@ -2374,38 +2302,36 @@
 #endif
 
-      CALL deposition(vdep_oce,vdep_sic,vdep_ter,vdep_lic,pctsrf,      &
-                     zrho,zdz,pdtphys,RHcl,masse,t_seri,pplay,paprs,  &
-                     lminmax,qmin,qmax,                               &
-                              his_ds,source_tr,tr_seri)
-!
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_depo')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after depo')
-        ENDDO
+    CALL deposition(vdep_oce, vdep_sic, vdep_ter, vdep_lic, pctsrf, &
+            zrho, zdz, pdtphys, RHcl, masse, t_seri, pplay, paprs, &
+            lminmax, qmin, qmax, &
+            his_ds, source_tr, tr_seri)
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_depo')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after depo')
+      ENDDO
       IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,   &
-           pplay,t_seri,iscm3,'after depo')
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'after depo')
         ENDDO
       ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after depo')
-      ENDIF
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_depo=dife*MAX(0,SIGN(1,dife))                      &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_depo=tia_depo+REAL(ti_depo)/REAL(clock_rate)
-      ENDIF
-
-
-!
-!======================================================================
-!    -- Boundary layer mixing --
-!======================================================================
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: after depo')
+    ENDIF
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+      dife = clock_end - clock_start
+      ti_depo = dife * MAX(0, SIGN(1, dife))                      &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_depo = tia_depo + REAL(ti_depo) / REAL(clock_rate)
+    ENDIF
+
+    !======================================================================
+    !    -- Boundary layer mixing --
+    !======================================================================
 
 #ifdef IOPHYS_DUST
@@ -2418,65 +2344,63 @@
 
 
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_start)
+    ENDIF
+
+    DO k = 1, klev
+      DO i = 1, klon
+        delp(i, k) = paprs(i, k) - paprs(i, k + 1)
+      END DO
+    END DO
+
+    DO itr = 1, nbtr
+      DO j = 1, klev
+        DO i = 1, klon
+          tmp_var(i, j) = tr_seri(i, j, itr)
+          aux_var2(i) = source_tr(i, itr)
+        ENDDO
+      ENDDO
+      IF (iflag_conv==2) THEN
+        ! Tiedke
+        CALL cltrac_spl(pdtphys, coefh, yu1, yv1, t_seri, tmp_var, &
+                aux_var2, paprs, pplay, aux_var3)
+
+      ELSE IF (iflag_conv>=3) THEN
+        !KE
+        CALL cltrac(pdtphys, coefh, t_seri, tmp_var, aux_var2, paprs, pplay, &
+                delp, aux_var3, d_tr_dry, flux_tr_dry(:, itr))
       ENDIF
 
-!
-
-       DO k = 1, klev
+      DO i = 1, klon
+        DO j = 1, klev
+          tr_seri(i, j, itr) = tmp_var(i, j)
+          d_tr(i, j, itr) = aux_var3(i, j)
+          d_tr_cl(i, j, itr) = d_tr(i, j, itr)
+        ENDDO
+      ENDDO
+      DO k = 1, klev
         DO i = 1, klon
-         delp(i,k) = paprs(i,k)-paprs(i,k+1)
-        END DO
-      END DO
-!
-      DO itr=1,nbtr
-      DO j=1, klev
-      DO i=1, klon
-        tmp_var(i,j)=tr_seri(i,j,itr)
-        aux_var2(i)=source_tr(i,itr)
-      ENDDO
-      ENDDO
-      IF (iflag_conv==2) THEN
-! Tiedke
-      CALL cltrac_spl(pdtphys,coefh,yu1,yv1,t_seri,tmp_var,  &
-                 aux_var2,paprs,pplay,aux_var3)
-
-      ELSE IF (iflag_conv>=3) THEN
-!KE
-      CALL cltrac(pdtphys, coefh,t_seri,tmp_var,aux_var2,paprs,pplay,  &
-                 delp,aux_var3,d_tr_dry,flux_tr_dry(:,itr))
+          tr_seri(i, k, itr) = tr_seri(i, k, itr) + d_tr(i, k, itr)
+        ENDDO
+      ENDDO
+      print *, ' AFTER Cltrac'
+      IF (lminmax) THEN
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after cltrac')
       ENDIF
-
-      DO i=1, klon
-      DO j=1, klev
-        tr_seri(i,j,itr)=tmp_var(i,j)
-        d_tr(i,j,itr)=aux_var3(i,j)
-        d_tr_cl(i,j,itr)=d_tr(i,j,itr)
-      ENDDO
-      ENDDO
-      DO k = 1, klev
-      DO i = 1, klon
-         tr_seri(i,k,itr) = tr_seri(i,k,itr) + d_tr(i,k,itr)
-      ENDDO
-      ENDDO
-      print *,' AFTER Cltrac'
-      IF (lminmax) THEN
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after cltrac')
-      ENDIF
-      ENDDO !--end itr loop
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_cltr=dife*MAX(0,SIGN(1,dife))     &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_cltr=tia_cltr+REAL(ti_cltr)/REAL(clock_rate)
-      ENDIF
-
-
-
-!======================================================================
-!    -- Calcul de l'effet des thermiques for KE--
-!======================================================================
+    ENDDO !--end itr loop
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+      dife = clock_end - clock_start
+      ti_cltr = dife * MAX(0, SIGN(1, dife))     &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_cltr = tia_cltr + REAL(ti_cltr) / REAL(clock_rate)
+    ENDIF
+
+
+
+    !======================================================================
+    !    -- Calcul de l'effet des thermiques for KE--
+    !======================================================================
 
 #ifdef IOPHYS_DUST
@@ -2494,194 +2418,187 @@
 
 
-      IF (iflag_conv>=3) THEN
+    IF (iflag_conv>=3) THEN
 
       IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+        CALL SYSTEM_CLOCK(COUNT = clock_start)
       ENDIF
 
-
-
-
-      
-       IF (lminmax) THEN
-        DO itr=1,nbtr
-       CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_before therm')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before therm')
-        ENDDO
+      IF (lminmax) THEN
+        DO itr = 1, nbtr
+          CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_before therm')
+        ENDDO
+        DO itr = 1, nbtr
+          CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before therm')
+        ENDDO
+        IF (lcheckmass) THEN
+          DO itr = 1, nbtr
+            CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                    pplay, t_seri, iscm3, 'before therm')
+          ENDDO
+        ENDIF
+        CALL minmaxsource(source_tr, qmin, qmax, 'before therm')
+      ENDIF
+
+      DO itr = 1, nbtr
+        DO k = 1, klev
+          DO i = 1, klon
+            tmp_var3(i, k, itr) = tr_seri(i, k, itr)
+            d_tr_th(i, k, itr) = 0.
+            tr_seri(i, k, itr) = MAX(tr_seri(i, k, itr), 0.)
+            !JE: precursor >>1e10         tr_seri(i,k,itr)=MIN(tr_seri(i,k,itr),1.e10)
+          END DO
+        END DO
+      END DO
+
+      !JE  new implicit scheme 20140323
+      DO itr = 1, nbtr
+        CALL thermcell_dq(klon, klev, 1, pdtphys, fm_therm, entr_therm, &
+                zmasse, tr_seri(1:klon, 1:klev, itr), &
+                d_tr(1:klon, 1:klev, itr), ztra_th, 0)
+
+        DO k = 1, klev
+          DO i = 1, klon
+            d_tr(i, k, itr) = pdtphys * d_tr(i, k, itr)
+            d_tr_th(i, k, itr) = d_tr_th(i, k, itr) + d_tr(i, k, itr)
+            tr_seri(i, k, itr) = MAX(tr_seri(i, k, itr) + d_tr(i, k, itr), 0.)
+          END DO
+        END DO
+
+      ENDDO
+
+      ! old scheme explicit
+      !       nsplit=10
+      !       DO itr=1,nbtr
+      !          DO isplit=1,nsplit
+      !              CALL dqthermcell(klon,klev,pdtphys/nsplit,
+      !     .            fm_therm,entr_therm,zmasse,
+      !     .            tr_seri(1:klon,1:klev,itr),
+      !     .            d_tr(1:klon,1:klev,itr),ztra_th)
+      !            DO k=1,klev
+      !               DO i=1,klon
+      !                  d_tr(i,k,itr)=pdtphys*d_tr(i,k,itr)/nsplit
+      !                  d_tr_th(i,k,itr)=d_tr_th(i,k,itr)+d_tr(i,k,itr)
+      !                  tr_seri(i,k,itr)=MAX(tr_seri(i,k,itr)+d_tr(i,k,itr),0.)
+      !               END DO
+      !            END DO
+      !         END DO ! nsplit1
+      !      END DO ! it
+      !JE end modif 20140323
+
+      DO itr = 1, nbtr
+        DO k = 1, klev
+          DO i = 1, klon
+            tmp_var(i, k) = tr_seri(i, k, itr) - tmp_var3(i, k, itr)
+          ENDDO
+        ENDDO
+        IF (lminmax) THEN
+          IF (lcheckmass) THEN
+            CALL checkmass(tmp_var(:, :), RNAVO, masse(itr), zdz, &
+                    pplay, t_seri, iscm3, 'dtr therm ')
+          ENDIF
+        ENDIF
+        CALL kg_to_cm3(pplay, t_seri, tmp_var)
+
+        DO k = 1, klev
+          DO i = 1, klon
+            his_th(i, itr) = his_th(i, itr) + &
+                    (tmp_var(i, k)) / RNAVO * &
+                            masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+          END DO !klon
+        END DO !klev
+
+      END DO !it
+      IF (lminmax) THEN
+        DO itr = 1, nbtr
+          CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after therm')
+        ENDDO
+        DO itr = 1, nbtr
+          CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after therm')
+        ENDDO
+        IF (lcheckmass) THEN
+          DO itr = 1, nbtr
+            CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                    pplay, t_seri, iscm3, 'after therm')
+          ENDDO
+        ENDIF
+        CALL minmaxsource(source_tr, qmin, qmax, 'after therm')
+      ENDIF
+
+      IF (logitime) THEN
+        CALL SYSTEM_CLOCK(COUNT = clock_end)
+        dife = clock_end - clock_start
+        ti_ther = dife * MAX(0, SIGN(1, dife))   &
+                + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+        tia_ther = tia_ther + REAL(ti_ther) / REAL(clock_rate)
+      ENDIF
+
+    ENDIF ! iflag_conv KE
+    !------------------------------------
+    !      Sedimentation
+    !-----------------------------------
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_start)
+    ENDIF
+
+    DO itr = 1, nbtr
+      DO j = 1, klev
+        DO i = 1, klon
+          tmp_var(i, j) = tr_seri(i, j, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO j = 1, klev
+        DO i = 1, klon
+          tr_seri(i, j, itr) = tmp_var(i, j)
+        ENDDO
+      ENDDO
+    ENDDO !--end itr loop
+    iscm3 = .true.
+    !--------------------------------------
+    print *, ' BEFORE Sediment'
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_before_sedi')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before sedi')
+      ENDDO
       IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'before therm')
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'before sedi')
         ENDDO
       ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'before therm')
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: before sedi')
+    ENDIF
+
+    print *, 'SPLA VERSION OF SEDIMENTATION IS USED'
+    CALL sediment_mod(t_seri, pplay, zrho, paprs, pdtphys, RHcl, &
+            id_coss, id_codu, id_scdu, &
+            ok_chimeredust, &
+            sed_ss, sed_dust, sed_dustsco, &
+            sed_ss3D, sed_dust3D, sed_dustsco3D, tr_seri)
+    CALL cm3_to_kg(pplay, t_seri, sed_ss3D)
+    CALL cm3_to_kg(pplay, t_seri, sed_dust3D)
+    CALL cm3_to_kg(pplay, t_seri, sed_dustsco3D)
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_sedi')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after sedi')
+      ENDDO
+      IF (lcheckmass) THEN
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'after sedi')
+        ENDDO
       ENDIF
-
-      DO itr=1,nbtr
-         DO k=1,klev
-            DO i=1,klon
-               tmp_var3(i,k,itr)=tr_seri(i,k,itr)
-               d_tr_th(i,k,itr)=0.
-               tr_seri(i,k,itr)=MAX(tr_seri(i,k,itr),0.)
-!JE: precursor >>1e10         tr_seri(i,k,itr)=MIN(tr_seri(i,k,itr),1.e10)
-            END DO
-         END DO
-      END DO
-
-!JE  new implicit scheme 20140323
-      DO itr=1,nbtr
-        CALL thermcell_dq(klon,klev,1,pdtphys,fm_therm,entr_therm,  &
-                         zmasse,tr_seri(1:klon,1:klev,itr),         &
-                         d_tr(1:klon,1:klev,itr),ztra_th,0 )
-
-        DO k=1,klev
-           DO i=1,klon
-              d_tr(i,k,itr)=pdtphys*d_tr(i,k,itr)
-              d_tr_th(i,k,itr)=d_tr_th(i,k,itr)+d_tr(i,k,itr)
-              tr_seri(i,k,itr)=MAX(tr_seri(i,k,itr)+d_tr(i,k,itr),0.)
-              END DO
-        END DO
-
-      ENDDO
-
-! old scheme explicit
-!       nsplit=10
-!       DO itr=1,nbtr
-!          DO isplit=1,nsplit
-!              CALL dqthermcell(klon,klev,pdtphys/nsplit, 
-!     .            fm_therm,entr_therm,zmasse, 
-!     .            tr_seri(1:klon,1:klev,itr),
-!     .            d_tr(1:klon,1:klev,itr),ztra_th)
-!            DO k=1,klev
-!               DO i=1,klon
-!                  d_tr(i,k,itr)=pdtphys*d_tr(i,k,itr)/nsplit
-!                  d_tr_th(i,k,itr)=d_tr_th(i,k,itr)+d_tr(i,k,itr)
-!                  tr_seri(i,k,itr)=MAX(tr_seri(i,k,itr)+d_tr(i,k,itr),0.)
-!               END DO
-!            END DO
-!         END DO ! nsplit1
-!      END DO ! it
-!JE end modif 20140323
-
-      DO itr=1,nbtr
-         DO k=1,klev
-            DO i=1,klon
-          tmp_var(i,k)=tr_seri(i,k,itr)-tmp_var3(i,k,itr)
-            ENDDO
-         ENDDO
-       IF (lminmax) THEN
-      IF (lcheckmass) THEN
-         CALL checkmass(tmp_var(:,:),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'dtr therm ')
-      ENDIF
-       ENDIF
-         CALL kg_to_cm3(pplay,t_seri,tmp_var)
-
-         DO k=1,klev
-            DO i=1,klon
-               his_th(i,itr)=his_th(i,itr)+    &
-                           (tmp_var(i,k))/RNAVO*   &
-                     masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys
-            END DO !klon
-         END DO !klev
-
-      END DO !it
-       IF (lminmax) THEN
-        DO itr=1,nbtr
-       CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after therm')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after therm')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,   &
-           pplay,t_seri,iscm3,'after therm')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'after therm')
-       ENDIF
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_ther=dife*MAX(0,SIGN(1,dife))   &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_ther=tia_ther+REAL(ti_ther)/REAL(clock_rate)
-      ENDIF
-
-
-      ENDIF ! iflag_conv KE
-!------------------------------------
-!      Sedimentation
-!-----------------------------------
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
-      ENDIF
-
-
-      DO itr=1,nbtr
-      DO j=1,klev
-      DO i=1,klon
-         tmp_var(i,j)=tr_seri(i,j,itr)
-      ENDDO
-      ENDDO
-      CALL kg_to_cm3(pplay,t_seri,tmp_var)
-      DO j=1,klev
-      DO i=1,klon
-         tr_seri(i,j,itr)=tmp_var(i,j)
-      ENDDO
-      ENDDO
-      ENDDO !--end itr loop
-      iscm3=.true.
-!--------------------------------------
-      print *,' BEFORE Sediment'
-
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_before_sedi')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before sedi')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,   &
-           pplay,t_seri,iscm3,'before sedi')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: before sedi')
-      ENDIF
-
-      print *,'SPLA VERSION OF SEDIMENTATION IS USED'
-      CALL sediment_mod(t_seri,pplay,zrho,paprs,pdtphys,RHcl,   & 
-                                     id_coss,id_codu,id_scdu,  &
-                                     ok_chimeredust,           &
-                         sed_ss,sed_dust,sed_dustsco,          &
-                         sed_ss3D,sed_dust3D,sed_dustsco3D,tr_seri)
-      CALL cm3_to_kg(pplay,t_seri,sed_ss3D)
-      CALL cm3_to_kg(pplay,t_seri,sed_dust3D)
-      CALL cm3_to_kg(pplay,t_seri,sed_dustsco3D)
-
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_sedi')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after sedi')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'after sedi')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after sedi')
-      ENDIF
-
-!
-!=======================================================================
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: after sedi')
+    ENDIF
+
+    !=======================================================================
 #ifdef IOPHYS_DUST
       do itr=1,nbtr
